//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Histgram.h"
#include "MdiFrame.h"
#include "MdiView.h"
#include "Text.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
THistgramForm *HistgramForm;
//---------------------------------------------------------------------------
__fastcall THistgramForm::THistgramForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall THistgramForm::FormShow(TObject *Sender)
{
    int i, x, len;
    int width, height;
    int count;

    FrameForm->RHistgram = true;
    FrameForm->Histgram1->Checked = true;
    FrameForm->SpeedButton43->Down = true;

	Left = FrameForm->RhgLeft;
    Top = FrameForm->RhgTop;

    count = FrameForm->MDIChildCount;
    if (FrameForm->ListSetting)
    	count--;

    if (FrameForm->RCanUndo == false && count > 0) {
    	if (FrameForm->AreaSetting)
        	ViewForm->ClearArea();

        width = ViewForm->Image1->Picture->Bitmap->Width;
    	height = ViewForm->Image1->Picture->Bitmap->Height;

		FrameForm->UndoBitmap->Width = width;
		FrameForm->UndoBitmap->Height = height;

    	FrameForm->UndoBitmap->Canvas->StretchDraw(Rect(0, 0, width, height),
     	 ViewForm->Image1->Picture->Bitmap);

        if (FrameForm->AreaSetting) {
        	ViewForm->DrawArea();
            if (FrameForm->TextSetting) {
            	TextForm->DrawText();
                TextForm->DrawRing();
            }
        }
    }

    GBitmap = new Graphics::TBitmap;

    GBitmap->Width = Image1->Width;
    GBitmap->Height = Image1->Height;

    GBitmap->Canvas->Brush->Color = clBtnFace;
    GBitmap->Canvas->FillRect(Rect(0, 0, GBitmap->Width, GBitmap->Height));

    GBitmap->Canvas->Pen->Color = clBlack;
    GBitmap->Canvas->MoveTo(10, 0);
    GBitmap->Canvas->LineTo(10, GBitmap->Height - 11);
    GBitmap->Canvas->LineTo(GBitmap->Width - 11, GBitmap->Height - 11);
    GBitmap->Canvas->LineTo(GBitmap->Width - 11, 0);

    GBitmap->Canvas->MoveTo(6, GBitmap->Height - 11 - 74);
    GBitmap->Canvas->LineTo(9, GBitmap->Height - 11 - 74);
    GBitmap->Canvas->MoveTo(GBitmap->Width - 10, GBitmap->Height - 11 - 74);
    GBitmap->Canvas->LineTo(GBitmap->Width - 7, GBitmap->Height - 11 - 74);

    GBitmap->Canvas->TextOut(GBitmap->Width - 8, GBitmap->Height - 11 - 64, "%");
    GBitmap->Canvas->Font->Size = 8;

    for (i = 0; i <= 16; i++) {
        x = i * 2 * 7 + 10;
        if (i % 2)
        	len = 1;
        else
        	len = 3;
    	GBitmap->Canvas->MoveTo(x, GBitmap->Height - 10);
        GBitmap->Canvas->LineTo(x, GBitmap->Height - 10 + len);

        if ((i % 4) == 0 && i < 16)
        	GBitmap->Canvas->TextOut(x - (i / 4) * 3, GBitmap->Height - 9,
             IntToStr(i * 16));
    }

    if (count == 0)
    	ClearHistgram();
    else
    	DispHistgram();
}
//---------------------------------------------------------------------------
void __fastcall THistgramForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	Action = caFree;	
}
//---------------------------------------------------------------------------
void __fastcall THistgramForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	FrameForm->RhgLeft = Left;
    FrameForm->RhgTop = Top;

    FrameForm->RHistgram = false;
    FrameForm->Histgram1->Checked = false;
    FrameForm->SpeedButton43->Down = false;

    delete GBitmap;
}
//---------------------------------------------------------------------------
void __fastcall THistgramForm::DispHistgram(void)
{
    int i, max, h;
    int x, y;
    int r[32];
    int g[32];
    int b[32];
    int width, height;
    int pixel;
    int red, green, blue;
    Graphics::TBitmap *bitmap;

    if (ViewForm->CanHG == false) {
    	ViewForm->CanHG = true;
        return;
    }

    width = FrameForm->UndoBitmap->Width;
    height = FrameForm->UndoBitmap->Height;

    while (width > 100 || height > 100) {
    	width /= 2;
        height /= 2;
    }

    bitmap = new Graphics::TBitmap;

    bitmap->Width = width;
    bitmap->Height = height;
    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), FrameForm->UndoBitmap);

    for (i = 0; i < 32; i++) {
    	r[i] = 0;
        g[i] = 0;
        b[i] = 0;
    }

    for (y = 0; y < height; y++) {
    	for (x = 0; x < width; x++) {
        	pixel = bitmap->Canvas->Pixels[x][y];
            red = pixel & 0x000000ff;
            green = (pixel & 0x0000ff00) >> 8;
            blue = (pixel & 0x00ff0000) >> 16;
            r[red / 8]++;
            g[green / 8]++;
            b[blue / 8]++;
        }
    }

    for (i = 0, max = 0; i < 32; i++) {
    	r[i] = r[i] * 100 / width / height;
        if (r[i] > max)
        	max = r[i];
        g[i] = g[i] * 100 / width / height;
        if (g[i] > max)
        	max = g[i];
        b[i] = b[i] * 100 / width / height;
        if (b[i] > max)
        	max = b[i];
    }

    h = max / 10;
    if (max % 10)
    	h++;
    h *= 10;

    bitmap->Width = GBitmap->Width;
    bitmap->Height = GBitmap->Height;
    bitmap->Canvas->StretchDraw(Rect(0, 0, bitmap->Width, bitmap->Height), GBitmap);

	bitmap->Canvas->Brush->Color = clBtnFace;
    bitmap->Canvas->Pen->Color = clBlack;
    bitmap->Canvas->Font->Size = 8;
    bitmap->Canvas->TextOut(bitmap->Width - 11, bitmap->Height - 11 - 74,
     IntToStr(h / 2));

    bitmap->Canvas->Pen->Color = (TColor)0x000000ff;
    for (i = 0, x = 13; i < 32; i++, x += 7) {
    	y = bitmap->Height - 11 - (r[i] * 150 / h);
        if (i == 0)
    		bitmap->Canvas->MoveTo(x, y);
        else
    		bitmap->Canvas->LineTo(x, y);
    }

    bitmap->Canvas->Pen->Color = (TColor)0x0000ff00;
    for (i = 0, x = 13; i < 32; i++, x += 7) {
    	y = bitmap->Height - 11 - (g[i] * 150 / h);
        if (i == 0)
    		bitmap->Canvas->MoveTo(x, y);
        else
    		bitmap->Canvas->LineTo(x, y);
    }

    bitmap->Canvas->Pen->Color = (TColor)0x00ff0000;
    for (i = 0, x = 13; i < 32; i++, x += 7) {
    	y = bitmap->Height - 11 - (b[i] * 150 / h);
        if (i == 0)
    		bitmap->Canvas->MoveTo(x, y);
        else
    		bitmap->Canvas->LineTo(x, y);
    }

    Image1->Canvas->StretchDraw(Rect(0, 0, Image1->Width, Image1->Height), bitmap);

    delete bitmap;
}
//---------------------------------------------------------------------------
void __fastcall THistgramForm::FormActivate(TObject *Sender)
{
    try {
    	if (FrameForm->TextSetting) {
			TextForm->DrawText();
    		TextForm->DrawRing();
    	}
    	else if (FrameForm->AreaSetting) {
			ViewForm->DrawArea();
    	}
    }
    catch (...) {
    	return;
    }
}
//---------------------------------------------------------------------------
void __fastcall THistgramForm::FormDeactivate(TObject *Sender)
{
    try {
    	if (FrameForm->AreaSetting)
			ViewForm->ClearArea();
    }
    catch (...) {
    	return;
    }
}
//---------------------------------------------------------------------------
void __fastcall THistgramForm::ClearHistgram(void)
{
	Image1->Canvas->StretchDraw(Rect(0, 0, Image1->Width, Image1->Height), GBitmap);
}
//---------------------------------------------------------------------------