//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\printers.hpp>
#pragma hdrstop

#include "MdiPreview.h"
#include "MdiView.h"
#include "MdiFrame.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPreviewForm *PreviewForm;
//---------------------------------------------------------------------------
__fastcall TPreviewForm::TPreviewForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::FormCreate(TObject *Sender)
{
    Bitmap = new Graphics::TBitmap;

    Bitmap->Width = ViewForm->Image1->Width * FrameForm->ratio / 100 / FrameForm->rr;
    Bitmap->Height = ViewForm->Image1->Height * FrameForm->ratio / 100 / FrameForm->rr;

    Bitmap->Canvas->StretchDraw(Rect(0, 0, Bitmap->Width - 1, Bitmap->Height - 1),
     ViewForm->Image1->Picture->Bitmap);

    Image2->Width = FrameForm->rx + 10;
    Image2->Height = FrameForm->ry + 10;

    ClientWidth = FrameForm->rx + 10;
    ClientHeight = FrameForm->ry + 10 + 35;

    if (ClientWidth < 144)
    	ClientWidth = 144;

    Button1->Top = ClientHeight - 29;
    Button2->Top = ClientHeight - 29;

    if (FrameForm->psw)
    	ViewForm->TurnBitmap(Bitmap, 90);

    Preview();
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::Preview(void)
{
    int lx, ly;
    int rx, ry;

    lx = FrameForm->Lx;
    ly = FrameForm->Ly;
    rx = FrameForm->rx;
    ry = FrameForm->ry;

    if (FrameForm->psw)
    	lx -= Bitmap->Width - 1;

	Image2->Canvas->Brush->Color = clWhite;
    Image2->Canvas->FillRect(Rect(5, 5, 5 + rx, 5 + ry));

    Image2->Canvas->StretchDraw(Rect(5 + lx, 5 + ly, 5 + lx + Bitmap->Width - 1,
     5 + ly + Bitmap->Height - 1), Bitmap);

    Image2->Canvas->Brush->Color = clBtnFace;
    Image2->Canvas->FillRect(Rect(0, 0, 5, 5 + ry + 5));
    Image2->Canvas->FillRect(Rect(0, 0, 5 + rx + 5, 5));
    Image2->Canvas->FillRect(Rect(5 + rx, 0, 5 + rx + 5, 5 + ry + 5));
    Image2->Canvas->FillRect(Rect(0, 5 + ry, 5 + rx + 5, 5 + ry + 5));

    Image2->Canvas->Pen->Width = 1;
    Image2->Canvas->Pen->Color = clWhite;
    Image2->Canvas->MoveTo(5 - 1, 5 + ry);
    Image2->Canvas->LineTo(5 - 1, 5 - 1);
    Image2->Canvas->LineTo(5 + rx, 5 - 1);
    Image2->Canvas->Pen->Color = clBlack;
    Image2->Canvas->LineTo(5 + rx, 5 + ry);
    Image2->Canvas->LineTo(5, 5 + ry);
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	delete Bitmap;
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::Image2MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	FrameForm->Lx = X - 5;
    FrameForm->Ly = Y - 5;

    Preview();
}
//---------------------------------------------------------------------------
