//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#include <vcl\printers.hpp>
#include <vcl\sysutils.hpp>
#include <vcl\clipbrd.hpp>
#include <vcl\graphics.hpp>
#include <vcl\classes.hpp>
#include <process.h>
#include <stdio.h>
#include <time.h>
#include <win32\shellapi.h>
#include <win32\winbase.h>
#include <win32\wingdi.h>
#include <win32\winuser.h>
#pragma hdrstop

#define __MAIN_PROGRAM__
#include "ImageKit.h"
#include "ImgkDef.h"

#include "SusieDef.h"

#include "MdiFrame.h"
#include "MdiView.h"
#include "DeRe.h"
#include "Err.h"
#include "NewImage.h"
#include "MdiList.h"
#include "ListSize.h"
#include "Opening.h"
#include "GetID.h"
#include "Text.h"
#include "OverView.h"
#include "Histgram.h"
#include "Control.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
#pragma resource "Cursor2.res"
TFrameForm *FrameForm;
//---------------------------------------------------------------------------
__fastcall TFrameForm::TFrameForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Exit1Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Tile1Click(TObject *Sender)
{
	Tile();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Cascade1Click(TObject *Sender)
{
	Cascade();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Arrangeicons1Click(TObject *Sender)
{
	ArrangeIcons();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Open1Click(TObject *Sender)
{
    int  i, count;
    int  pos;
    bool areasetting;
    bool textsetting;
    AnsiString OpenName;

    if (ListSetting) {
    	if (ListForm->WindowState == wsMaximized)
    		ListForm->WindowState = wsNormal;
    }

    areasetting = AreaSetting;
    textsetting = TextSetting;

    if (textsetting)
    	ViewForm->Text1Click(Sender);
    else if (areasetting)
    	ViewForm->Areasetting1Click(Sender);

    if (ROpenDir != "")
    	OpenFileDialog->InitialDir = ROpenDir;

    OpenFileDialog->FilterIndex = ROpenFileType;

	if (OpenFileDialog->Execute()) {
        count = OpenFileDialog->Files->Count;

        for (i = 0; i < count; i++) {
    		ViewForm = new TViewForm (this);
        	ViewForm->Open(OpenFileDialog->Files->Strings[i]);
        }

        OpenName = OpenFileDialog->FileName;
        pos = OpenName.Pos(ExtractFileName(OpenName));
        if (pos > 4)
        	pos--;
        OpenName.SetLength(pos - 1);

        ROpenDir = OpenName;
        ROpenFileType = OpenFileDialog->FilterIndex;

        if (DrawSetting && count > 0) {
    		ViewForm->SetDrawColor();
        	ViewForm->Image1->Cursor = (TCursor)1;
        }
    }
    else {
        if (textsetting)
    		ViewForm->Text1Click(Sender);
    	else if (areasetting)
    		ViewForm->Areasetting1Click(Sender);
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::FormCreate(TObject *Sender)
{
	TRegistry *Reg = new TRegistry;

    Reg->RootKey = HKEY_CURRENT_USER;

    if (Reg->OpenKey("\\Control Panel\\desktop", false)) {
    	TileWallpaper = Reg->ReadString("TileWallpaper");
        Reg->CloseKey();
    }
    else
    	TileWallpaper = "";

    Reg->RootKey = HKEY_LOCAL_MACHINE;

    if (Reg->OpenKey("\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion", false)) {
    	SystemRoot = Reg->ReadString("SystemRoot");
        Reg->CloseKey();
    }
    else
    	SystemRoot = "";

    if (Reg->OpenKey("\\SOFTWARE\\seizo\\Image Viewer", false)) {
    	RTempDir = Reg->ReadString("RTempDir");
        Reg->CloseKey();
    }
    else
    	RTempDir = "";

    Reg->RootKey = HKEY_CURRENT_USER;

    delete Reg;

    Stretch = false;
    AreaSetting = false;
    Abitmap = new Graphics::TBitmap;
    Awidth = 100;
    Aheight = 100;
    AreaText = "";
    ACIndex = 12;
    AreaColor = clBlue;
    TextSetting = false;
    Textbitmap = new Graphics::TBitmap;
    Textbitmap->Width = 100;
    Textbitmap->Height = 100;
    Textbitmap->Canvas->Brush->Color = clWhite;
    Textbitmap->Canvas->Brush->Style = bsClear;
    DrawSetting = false;
    Drawing = false;
    DrawTool = 49;				// 
    DrawColor = clBlue;
    DrawInColor = clBtnFace;
    DrawIn = false;
    DrawWidth = 1;
    UndoBitmap = new Graphics::TBitmap;
    UndoHandleCount = 0;
    UndoHandle = 0;
    UndoWidth = 0;
    UndoHeight = 0;
    UndoModefied = false;
    TimerOn = false;
    TimerCancel = false;
    ListSetting = false;
    NewImageCount = 1;
    HexRGB = false;
    PluginCount = 0;
    PluginFiles = new TStringList;
    psw = false;
    preview = false;
    rr = 4;
//  SetPrinterParam();

    SusieCheck();

    LoadImgKitDll();

    Opening(true);

    Application->OnIdle = &OnIdle;			// OnIdle method

    Screen->Cursors[1] = ::LoadCursor((HINSTANCE)HInstance, "PENCIL2");
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::ErrMsgOut(const AnsiString str)
{
	ErrForm = new TErrForm (this);

    ErrForm->Label1->Caption = str;
    ErrForm->ClientWidth = ErrForm->Label1->Width + 16;
    ErrForm->Button1->Left = ErrForm->ClientWidth / 2 - 28;

    ErrForm->ShowModal();

    delete ErrForm;
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SetPrinterParam(void)
{
	int	t;

    Printer()->BeginDoc();

    pwidth = GetDeviceCaps(Printer()->Canvas->Handle, HORZRES);
    pheight = GetDeviceCaps(Printer()->Canvas->Handle, VERTRES);

    px = GetDeviceCaps(Printer()->Canvas->Handle, LOGPIXELSX);
    py = GetDeviceCaps(Printer()->Canvas->Handle, LOGPIXELSY);

    Printer()->Abort();

    if (pwidth > pheight) {
        psw = true;
        if (pwidth == 2749)
    		psw = false;
    }
    else {
    	psw = false;
    	if (pwidth == 1843)
    		psw = true;
    }

    rx = pwidth * 80 / rr / px;
    ry = pheight * 80 / rr / py;

    Lx = 0;
    Ly = 0;

    if (psw) {
    	t = rx;
        rx = ry;
        ry = t;
        Lx = rx - 1;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::About1Click(TObject *Sender)
{
    int	pos, len;
	AnsiString FileName;
    AnsiString Ext;

    FileName = Application->ExeName;
    Ext = ExtractFileName(FileName);
    pos = FileName.Pos(Ext);
    len = Ext.Length();
    FileName.Delete(pos, len);
    FileName += "Iv.txt";

	spawnlp(P_NOWAIT, "NOTEPAD.EXE", "NOTEPAD.EXE", FileName.c_str(), NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Operation1Click(TObject *Sender)
{
    int	pos, len;
	AnsiString FileName;
    AnsiString Ext;

    FileName = Application->ExeName;
    Ext = ExtractFileName(FileName);
    pos = FileName.Pos(Ext);
    len = Ext.Length();
    FileName.Delete(pos, len);
    FileName += "Ivopr.txt";

	spawnlp(P_NOWAIT, "NOTEPAD.EXE", "NOTEPAD.EXE", FileName.c_str(), NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Technique1Click(TObject *Sender)
{
    int	pos, len;
	AnsiString FileName;
    AnsiString Ext;

    FileName = Application->ExeName;
    Ext = ExtractFileName(FileName);
    pos = FileName.Pos(Ext);
    len = Ext.Length();
    FileName.Delete(pos, len);
    FileName += "Ivtec.txt";

	spawnlp(P_NOWAIT, "NOTEPAD.EXE", "NOTEPAD.EXE", FileName.c_str(), NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::FormDestroy(TObject *Sender)
{
	UnLoadImgKitDll();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::LoadImgKitDll(void)
{
	hInstIMGCOM  = LoadLibrary("IMGCOM3.DLL");
	hInstIMGSCAN = LoadLibrary("IMGSCAN3.DLL");
	hInstIMGETC  = LoadLibrary("IMGETC3.DLL");
	hInstIMGFILE = LoadLibrary("IMGFILE3.DLL");
	hInstIMGDSP  = LoadLibrary("IMGDSP3.DLL");
	hInstIMGCUT  = LoadLibrary("IMGCUT3.DLL");
	hInstIMGTIFF = LoadLibrary("IMGTIFF3.DLL");

	lpFuncImgKitMemSize       = (PROCIMGKITMEMSIZE)GetProcAddress(hInstIMGCOM, "ImgKitMemSize");
	lpFuncImgKitMemFree       = (PROCIMGKITMEMFREE)GetProcAddress(hInstIMGCOM, "ImgKitMemFree");
	lpFuncImgKitSystemPalette = (PROCIMGKITSYSTEMPALETTE)GetProcAddress(hInstIMGCOM, "ImgKitSystemPalette");

	lpFuncImgKitScanSelect    = (PROCIMGKITSCANSELECT)GetProcAddress(hInstIMGSCAN, "ImgKitScanSelect");
	lpFuncImgKitScan          = (PROCIMGKITSCAN)GetProcAddress(hInstIMGSCAN, "ImgKitScan");
	lpFuncImgKitScanEasy      = (PROCIMGKITSCANEASY)GetProcAddress(hInstIMGSCAN, "ImgKitScanEasy");
	lpFuncImgKitScanMulti     = (PROCIMGKITSCANMULTI)GetProcAddress(hInstIMGSCAN, "ImgKitScanMulti");

	lpFuncImgKitRotation      = (PROCIMGKITROTATION)GetProcAddress(hInstIMGETC, "ImgKitRotation");
	lpFuncImgKitBit24To8      = (PROCIMGKITBIT24TO8)GetProcAddress(hInstIMGETC, "ImgKitBit24To8");
	lpFuncImgKitBit8To4       = (PROCIMGKITBIT8TO4)GetProcAddress(hInstIMGETC, "ImgKitBit8To4");
	lpFuncImgKitSetGray       = (PROCIMGKITSETGRAY)GetProcAddress(hInstIMGETC, "ImgKitSetGray");
	lpFuncImgKitImageSize     = (PROCIMGKITIMAGESIZE)GetProcAddress(hInstIMGETC, "ImgKitImageSize");
	lpFuncImgKitImageInfo     = (PROCIMGKITIMAGEINFO)GetProcAddress(hInstIMGETC, "ImgKitImageInfo");
	lpFuncImgKitEmboss        = (PROCIMGKITEMBOSS)GetProcAddress(hInstIMGETC, "ImgKitEmboss");
	lpFuncImgKitColorReverse  = (PROCIMGKITCOLORREVERSE)GetProcAddress(hInstIMGETC, "ImgKitColorReverse");
	lpFuncImgKitColor24And8   = (PROCIMGKITCOLOR24AND8)GetProcAddress(hInstIMGETC, "ImgKitColor24And8");
	lpFuncImgKitMosaic        = (PROCIMGKITMOSAIC)GetProcAddress(hInstIMGETC, "ImgKitMosaic");
	lpFuncImgKitFilter        = (PROCIMGKITFILTER)GetProcAddress(hInstIMGETC, "ImgKitFilter");
	lpFuncImgKitCopy          = (PROCIMGKITCOPY)GetProcAddress(hInstIMGETC, "ImgKitCopy");

	lpFuncImgKitFileLoad      = (PROCIMGKITFILELOAD)GetProcAddress(hInstIMGFILE, "ImgKitFileLoad");
	lpFuncImgKitJpegFileLoad  = (PROCIMGKITJPEGFILELOAD)GetProcAddress(hInstIMGFILE, "ImgKitJpegFileLoad");
	lpFuncImgKitBmpFileSave   = (PROCIMGKITBMPFILESAVE)GetProcAddress(hInstIMGFILE, "ImgKitBmpFileSave");
	lpFuncImgKitJpegFileSave  = (PROCIMGKITJPEGFILESAVE)GetProcAddress(hInstIMGFILE, "ImgKitJpegFileSave");
	lpFuncImgKitSuperFileSave = (PROCIMGKITSUPERFILESAVE)GetProcAddress(hInstIMGFILE, "ImgKitSuperFileSave");
	lpFuncImgKitGifFileSave   = (PROCIMGKITGIFFILESAVE)GetProcAddress(hInstIMGFILE, "ImgKitGifFileSave");
	lpFuncImgKitGifInterFileSave = (PROCIMGKITGIFINTERFILESAVE)GetProcAddress(hInstIMGFILE, "ImgKitGifInterFileSave");
	lpFuncImgKitGifFileLoad   = (PROCIMGKITGIFFILELOAD)GetProcAddress(hInstIMGFILE, "ImgKitGifFileLoad");
	lpFuncImgKitDisplay       = (PROCIMGKITDISPLAY)GetProcAddress(hInstIMGDSP, "ImgKitDisplay");
	lpFuncImgKitDisplayHdc    = (PROCIMGKITDISPLAYHDC)GetProcAddress(hInstIMGDSP, "ImgKitDisplayHdc");
	lpFuncImgKitPrintStart    = (PROCIMGKITPRINTSTART)GetProcAddress(hInstIMGDSP, "ImgKitPrintStart");
	lpFuncImgKitPrint         = (PROCIMGKITPRINT)GetProcAddress(hInstIMGDSP, "ImgKitPrint");
	lpFuncImgKitPrintEnd      = (PROCIMGKITPRINTEND)GetProcAddress(hInstIMGDSP, "ImgKitPrintEnd");

	lpFuncImgKitCut           = (PROCIMGKITCUT)GetProcAddress(hInstIMGCUT, "ImgKitCut");

	lpFuncImgKitTiffFileSave   = (PROCIMGKITTIFFFILESAVE)GetProcAddress(hInstIMGTIFF, "ImgKitTiffFileSave");
	lpFuncImgKitTiffFileLoad   = (PROCIMGKITTIFFFILELOAD)GetProcAddress(hInstIMGTIFF, "ImgKitTiffFileLoad");
	lpFuncImgKitRectCut        = (PROCIMGKITRECTCUT)GetProcAddress(hInstIMGCUT, "ImgKitRectCut");
	lpFuncImgKitGetFromClipBrd = (PROCIMGKITGETFROMCLIPBRD)GetProcAddress(hInstIMGETC, "ImgKitGetFromClipBrd");
	lpFuncImgKitSetToClipBrd   = (PROCIMGKITSETTOCLIPBRD)GetProcAddress(hInstIMGETC, "ImgKitSetToClipBrd");
	lpFuncImgKitBright         = (PROCIMGKITBRIGHT)GetProcAddress(hInstIMGETC, "ImgKitBright");
	lpFuncImgKitRGB            = (PROCIMGKITRGB)GetProcAddress(hInstIMGETC, "ImgKitRGB");

	lpFuncImgKitFileType       = (PROCIMGKITFILETYPE)GetProcAddress(hInstIMGFILE, "ImgKitFileType");
	lpFuncImgKitImageAdd       = (PROCIMGKITIMAGEADD)GetProcAddress(hInstIMGETC, "ImgKitImageAdd");
	lpFuncImgKitConvertColor   = (PROCIMGKITCONVERTCOLOR)GetProcAddress(hInstIMGETC, "ImgKitConvertColor");
	lpFuncImgKitDisplayRGB     = (PROCIMGKITDISPLAYRGB)GetProcAddress(hInstIMGDSP, "ImgKitDisplayRGB");
	lpFuncImgKitDisplayHdcRGB  = (PROCIMGKITDISPLAYHDCRGB)GetProcAddress(hInstIMGDSP, "ImgKitDisplayHdcRGB");
	lpFuncImgKitDisplayHdcXY   = (PROCIMGKITDISPLAYHDCXY)GetProcAddress(hInstIMGDSP, "ImgKitDisplayHdcXY");
	lpFuncImgKitDisplayXY      = (PROCIMGKITDISPLAYXY)GetProcAddress(hInstIMGDSP, "ImgKitDisplayXY");
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::UnLoadImgKitDll(void)
{
	FreeLibrary(hInstIMGCOM);
	FreeLibrary(hInstIMGSCAN);
	FreeLibrary(hInstIMGETC);
	FreeLibrary(hInstIMGFILE);
	FreeLibrary(hInstIMGDSP);
	FreeLibrary(hInstIMGCUT);
	FreeLibrary(hInstIMGTIFF);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::New1Click(TObject *Sender)
{
    int width, height;
    TColor color;
    AnsiString ImageName;
    bool areasetting;
    bool textsetting;

    if (ListSetting) {
    	if (ListForm->WindowState == wsMaximized)
    		ListForm->WindowState = wsNormal;
    }

    areasetting = AreaSetting;
    textsetting = TextSetting;

    if (textsetting)
    	ViewForm->Text1Click(Sender);
    else if (areasetting)
    	ViewForm->Areasetting1Click(Sender);

	NewImageForm = new TNewImageForm (this);

    NewImageForm->ShowModal();

    if (NewImageForm->ModalResult != mrOk) {
    	delete NewImageForm;

        if (textsetting)
    		ViewForm->Text1Click(Sender);
    	else if (areasetting)
    		ViewForm->Areasetting1Click(Sender);

        return;
    }

    try {
    	width = StrToInt(NewImageForm->Edit1->Text.Trim());
    	height = StrToInt(NewImageForm->Edit2->Text.Trim());
    	color = NewImageForm->Panel1->Color;
    }
    catch(...) {
    	delete NewImageForm;
        ShowMessage("͒l܂B");

        if (textsetting)
    		ViewForm->Text1Click(Sender);
    	else if (areasetting)
    		ViewForm->Areasetting1Click(Sender);

        return;
    }

    delete NewImageForm;

    RNewImageWidth = width;
    RNewImageHeight = height;
    RNewImageColor = (int)color;

    ImageName = "Image" + IntToStr(NewImageCount) + ".bmp";
    NewImageCount++;

    ViewForm = new TViewForm (this);
    ViewForm->NewImage(ImageName, width, height, color);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	int	pos, len;
	AnsiString FileName;
    AnsiString Ext;

    FileName = Application->ExeName;
    Ext = ExtractFileName(FileName);
    pos = FileName.Pos(Ext);
    len = Ext.Length();
    FileName.Delete(pos, len);
    FileName += "Ivfont.dat";

    FontDialog1->Font = Textbitmap->Canvas->Font;

    TFileStream *F = new TFileStream(FileName, fmOpenWrite | fmCreate);
    F->WriteComponent(FontDialog1);
    F->Free();

    TRegistry *Reg = new TRegistry;

    Reg->RootKey = HKEY_CURRENT_USER;

    Reg->OpenKey("\\Software\\seizo\\Image Viewer", true);

    Reg->WriteInteger("RUserID", RUserID);
    Reg->WriteInteger("RProgramID", RProgramID);
    Reg->WriteString("ROpenDir", ROpenDir);
    Reg->WriteInteger("ROpenFileType", ROpenFileType);
    Reg->WriteString("RListDir", RListDir);
    Reg->WriteInteger("RListFileType", RListFileType);
    Reg->WriteInteger("RListSize", RListSize);
    Reg->WriteInteger("RMaxImageWidth", RMaxImageWidth);
    Reg->WriteInteger("RListSquare", RListSquare);
    Reg->WriteInteger("RListSizes", RListSizes);
    Reg->WriteString("RSaveDir", RSaveDir);
    Reg->WriteInteger("RSaveFileType", RSaveFileType);
    Reg->WriteInteger("RJpegRatio", RJpegRatio);
    Reg->WriteInteger("RIconSize", RIconSize);
    Reg->WriteInteger("RNewImageWidth", RNewImageWidth);
    Reg->WriteInteger("RNewImageHeight", RNewImageHeight);
    Reg->WriteInteger("RNewImageColor", RNewImageColor);
    Reg->WriteInteger("RBlankUp", RBlankUp);
    Reg->WriteInteger("RBlankDown", RBlankDown);
    Reg->WriteInteger("RBlankLeft", RBlankLeft);
    Reg->WriteInteger("RBlankRight", RBlankRight);
    Reg->WriteInteger("RBlankColor", RBlankColor);
    Reg->WriteInteger("RTrimUp", RTrimUp);
    Reg->WriteInteger("RTrimDown", RTrimDown);
    Reg->WriteInteger("RTrimLeft", RTrimLeft);
    Reg->WriteInteger("RTrimRight", RTrimRight);
    Reg->WriteInteger("RPrintRatio", RPrintRatio);
	Reg->WriteInteger("RContrastMax", RContrastMax);
    Reg->WriteInteger("RContrastMin", RContrastMin);
    Reg->WriteInteger("RBright", RBright);
    Reg->WriteInteger("RMonoColor", RMonoColor);
    Reg->WriteBool("RMonochrome", RMonochrome);
    Reg->WriteBool("RFramingShape", RFramingShape);
    Reg->WriteInteger("RFramingWidth", RFramingWidth);
    Reg->WriteInteger("RFramingRatio", RFramingRatio);
    Reg->WriteInteger("RRedElement", RRedElement);
    Reg->WriteInteger("RGreenElement", RGreenElement);
    Reg->WriteInteger("RBlueElement", RBlueElement);
    Reg->WriteInteger("RReduceColor", RReduceColor);
    Reg->WriteBool("RReducePallet", RReducePallet);
    Reg->WriteBool("RReduceDither", RReduceDither);
    Reg->WriteInteger("REdge", REdge);
    Reg->WriteInteger("RSobel", RSobel);
    Reg->WriteInteger("RPaintSobel", RPaintSobel);
    Reg->WriteInteger("RMosaic", RMosaic);
    Reg->WriteInteger("RMedian", RMedian);
    Reg->WriteInteger("RPoster", RPoster);
    Reg->WriteInteger("RPenMode", RPenMode);
    Reg->WriteInteger("RVaguePaint", RVaguePaint);
    Reg->WriteInteger("RCopyMode", RCopyMode);
    Reg->WriteBool("RMenuSpeedBar", RMenuSpeedBar);
    Reg->WriteBool("RDrawSpeedBar", RDrawSpeedBar);
    Reg->WriteBool("RCanUndo", RCanUndo);
    Reg->WriteInteger("RMaxUndoCount", RMaxUndoCount);
    Reg->WriteBool("ROverView", ROverView);
    Reg->WriteInteger("RovLeft", RovLeft);
    Reg->WriteInteger("RovTop", RovTop);
    Reg->WriteInteger("RovWidth", RovWidth);
    Reg->WriteInteger("RovHeight", RovHeight);
    Reg->WriteBool("RHistgram", RHistgram);
    Reg->WriteInteger("RhgLeft", RhgLeft);
    Reg->WriteInteger("RhgTop", RhgTop);
    Reg->WriteBool("RHorzText", RHorzText);
    Reg->WriteInteger("RHorzTextSpace", RHorzTextSpace);
    if (Textbitmap->Canvas->Brush->Style == bsClear) {
        RTextbg = false;
        RTextbgColor = clBtnFace;
    }
    else {
        RTextbg = true;
        RTextbgColor = (int)(Textbitmap->Canvas->Brush->Color);
    }
    Reg->WriteBool("RTextbg", RTextbg);
    Reg->WriteInteger("RTextbgColor", RTextbgColor);
    RWindowState = (int)WindowState;
    Reg->WriteInteger("RWindowState", RWindowState);
    if (RWindowState == 0) {
    	RLeft = Left;
        RTop = Top;
        RWidth = Width;
        RHeight = Height;
    }
    Reg->WriteInteger("RLeft", RLeft);
    Reg->WriteInteger("RTop", RTop);
    Reg->WriteInteger("RWidth", RWidth);
    Reg->WriteInteger("RHeight", RHeight);

    Reg->CloseKey();

    delete Reg;

	delete Abitmap;
    delete Textbitmap;
    delete UndoBitmap;
    delete PluginFiles;

    if (ROverView) {
    	OverViewForm->Close();
    }

    if (RHistgram) {
    	HistgramForm->Close();
    }
}
//---------------------------------------------------------------------------

void __fastcall TFrameForm::FormShow(TObject *Sender)
{
    int i;
    int	pos, len;
	AnsiString FileName;
    AnsiString Ext;
    HANDLE hFindFile;
    WIN32_FIND_DATA FindData;

    Tag = 2;

    Caption = "Image Viewer Version 2.00";

    TRegistry *Reg = new TRegistry;

    Reg->RootKey = HKEY_CURRENT_USER;

    if (Reg->OpenKey("\\Software\\seizo\\Image Viewer", false)) {
        ROpenDir = Reg->ReadString("ROpenDir");
	    ROpenFileType = Reg->ReadInteger("ROpenFileType");
        RListDir = Reg->ReadString("RListDir");
	    RListFileType = Reg->ReadInteger("RListFileType");
        RListSize = Reg->ReadInteger("RListSize");
        RMaxImageWidth = Reg->ReadInteger("RMaxImageWidth");
        RListSquare = Reg->ReadInteger("RListSquare");
        RListSizes = Reg->ReadInteger("RListSizes");
        RSaveDir = Reg->ReadString("RSaveDir");
	    RSaveFileType = Reg->ReadInteger("RSaveFileType");
    	RJpegRatio = Reg->ReadInteger("RJpegRatio");
        RIconSize = Reg->ReadInteger("RIconSize");
        RNewImageWidth = Reg->ReadInteger("RNewImageWidth");
        RNewImageHeight = Reg->ReadInteger("RNewImageHeight");
        RNewImageColor = Reg->ReadInteger("RNewImageColor");
        RBlankUp = Reg->ReadInteger("RBlankUp");
        RBlankDown = Reg->ReadInteger("RBlankDown");
        RBlankLeft = Reg->ReadInteger("RBlankLeft");
        RBlankRight = Reg->ReadInteger("RBlankRight");
        RBlankColor = Reg->ReadInteger("RBlankColor");
        RTrimUp = Reg->ReadInteger("RTrimUp");
        RTrimDown = Reg->ReadInteger("RTrimDown");
        RTrimLeft = Reg->ReadInteger("RTrimLeft");
        RTrimRight = Reg->ReadInteger("RTrimRight");
        RPrintRatio = Reg->ReadInteger("RPrintRatio");
        RContrastMax = Reg->ReadInteger("RContrastMax");
        RContrastMin = Reg->ReadInteger("RContrastMin");
        RBright = Reg->ReadInteger("RBright");
        RMonoColor = Reg->ReadInteger("RMonoColor");
        RMonochrome = Reg->ReadBool("RMonochrome");
        RFramingShape = Reg->ReadBool("RFramingShape");
        RFramingWidth = Reg->ReadInteger("RFramingWidth");
        RFramingRatio = Reg->ReadInteger("RFramingRatio");
        RRedElement = Reg->ReadInteger("RRedElement");
        RGreenElement = Reg->ReadInteger("RGreenElement");
        RBlueElement = Reg->ReadInteger("RBlueElement");
        RReduceColor = Reg->ReadInteger("RReduceColor");
        RReducePallet = Reg->ReadBool("RReducePallet");
        RReduceDither = Reg->ReadBool("RReduceDither");
        REdge = Reg->ReadInteger("REdge");
        RSobel = Reg->ReadInteger("RSobel");
        RPaintSobel = Reg->ReadInteger("RPaintSobel");
        RMosaic = Reg->ReadInteger("RMosaic");
        RMedian = Reg->ReadInteger("RMedian");
        RPoster = Reg->ReadInteger("RPoster");
        RPenMode = Reg->ReadInteger("RPenMode");
        RVaguePaint = Reg->ReadInteger("RVaguePaint");
        RCopyMode = Reg->ReadInteger("RCopyMode");
        RMenuSpeedBar = Reg->ReadBool("RMenuSpeedBar");
        RDrawSpeedBar = Reg->ReadBool("RDrawSpeedBar");
        RCanUndo = Reg->ReadBool("RCanUndo");
        RMaxUndoCount = Reg->ReadInteger("RMaxUndoCount");
        ROverView = Reg->ReadBool("ROverView");
    	RovLeft = Reg->ReadInteger("RovLeft");
    	RovTop = Reg->ReadInteger("RovTop");
    	RovWidth = Reg->ReadInteger("RovWidth");
    	RovHeight = Reg->ReadInteger("RovHeight");
        RHistgram = Reg->ReadBool("RHistgram");
    	RhgLeft = Reg->ReadInteger("RhgLeft");
    	RhgTop = Reg->ReadInteger("RhgTop");
        RHorzText = Reg->ReadBool("RHorzText");
    	RHorzTextSpace = Reg->ReadInteger("RHorzTextSpace");
        RTextbg = Reg->ReadBool("RTextbg");
    	RTextbgColor = Reg->ReadInteger("RTextbgColor");
    	RWindowState = Reg->ReadInteger("RWindowState");
        RLeft = Reg->ReadInteger("RLeft");
        RTop = Reg->ReadInteger("RTop");
        RWidth = Reg->ReadInteger("RWidth");
        RHeight = Reg->ReadInteger("RHeight");

        if (RWindowState == 0) {
        	Left = RLeft;
            Top = RTop;
            Width = RWidth;
            Height = RHeight;
        }

        Reg->CloseKey();
    }
    else {
    	Reg->CreateKey("\\Software\\seizo\\Image Viewer");

        ROpenDir = "";
        ROpenFileType = 2;
        RListDir = "";
        RListFileType = 2;
        RListSize = 80;
        RMaxImageWidth = 700;
        RListSquare = 0;
        RListSizes = 0;
        RSaveDir = "";
        RSaveFileType = 2;
    	RJpegRatio = 75;
        RIconSize = 32;
        RNewImageWidth = 300;
        RNewImageHeight = 400;
        RNewImageColor = (int)clWhite;
        RBlankUp = 10;
        RBlankDown = 10;
        RBlankLeft = 10;
        RBlankRight = 10;
        RBlankColor = (int)clWhite;
        RTrimUp = 10;
        RTrimDown = 10;
        RTrimLeft = 10;
        RTrimRight = 10;
        RPrintRatio = 50;
        RContrastMax = 0;
        RContrastMin = 0;
        RBright = 0;
        RMonoColor = (int)clBlue;
        RMonochrome = false;
        RFramingShape = true;
        RFramingWidth = 10;
        RFramingRatio = 200;
        RRedElement = 0;
        RGreenElement = 0;
        RBlueElement = 0;
        RReduceColor = 1;
        RReducePallet = false;
        RReduceDither = false;
        REdge = 50;
        RSobel = 50;
        RPaintSobel = 50;
        RMosaic = 30;
        RMedian = 50;
        RPoster = 4;
        RPenMode = (int)pmCopy;
        RVaguePaint = 0;
        RCopyMode = (int)cmSrcCopy;
        RMenuSpeedBar = true;
        RDrawSpeedBar = true;
        RCanUndo = false;
        RMaxUndoCount = 30;
        ROverView = false;
    	RovLeft = Screen->Width - 210 - 22;
    	RovTop = 100 + 4;
    	RovWidth = 210;
    	RovHeight = 210;
        RHistgram = false;
    	RhgLeft = Screen->Width - 220 - 47;
    	RhgTop = Screen->Height - 187 - 58;
        RHorzText = false;
    	RHorzTextSpace = 0;
        RTextbg = false;
        RTextbgColor = clBtnFace;
    	RWindowState = 0;
        RLeft = Left;
        RTop = Top;
        RWidth = Width;
        RHeight = Height;
    }

    delete Reg;

    Panel1->Visible = RMenuSpeedBar;
    Speed1->Checked = RMenuSpeedBar;

    Panel2->Visible = RDrawSpeedBar;
    Speed2->Checked = RDrawSpeedBar;

    Image1->Canvas->Refresh();
    Image1->Canvas->MoveTo(0, 11);
    Image1->Canvas->LineTo(30, 11);

    Image1->Canvas->Brush->Color = clWhite;
    Image1->Canvas->Brush->Style = bsSolid;

    SpeedButton48->Down = RCanUndo;
    EnableUndo1->Checked = RCanUndo;

    if (RCanUndo) {
    	EnableUndo1->Caption = "޳𖳌(&E)";
        SpeedButton48->Hint = "޳𖳌ɂ";
    }
    else {
    	EnableUndo1->Caption = "޳L(&E)";
        SpeedButton48->Hint = "޳Lɂ";
    }

    InitUndoData();

    if (RWindowState != 0)
    	WindowState = (TWindowState)(RWindowState);

    if (ParamCount() > 0) {
    	for (i = 1; i <= ParamCount(); i++) {
    		ViewForm = new TViewForm (this);
    		ViewForm->Open(ParamStr(i));
        }
    }

    DragAcceptFiles(Handle, true);

    if (ROverView) {
    	OverViewForm = new TOverViewForm (Application);
    	OverViewForm->Show();
    }

    if (RHistgram) {
    	HistgramForm = new THistgramForm (Application);
    	HistgramForm->Show();
    }

    FileName = Application->ExeName;
    Ext = ExtractFileName(FileName);
    pos = FileName.Pos(Ext);
    len = Ext.Length();
    FileName.Delete(pos, len);
    FileName += "Ivfont.dat";

    hFindFile = FindFirstFile(FileName.c_str(), &FindData);
    if (hFindFile != INVALID_HANDLE_VALUE) {
    	TFileStream *F = new TFileStream(FileName, fmOpenRead);
    	F->ReadComponent(FontDialog1);
    	F->Free();
    	Textbitmap->Canvas->Font = FontDialog1->Font;
    	FindClose(hFindFile);
    }

    if (RTextbg) {
    	Textbitmap->Canvas->Brush->Style = TBrushStyle();
        Textbitmap->Canvas->Brush->Color = (TColor)RTextbgColor;
        Textbitmap->Canvas->Brush->Style = bsSolid;
    }
    else {
    	Textbitmap->Canvas->Brush->Style = bsClear;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::FormResize(TObject *Sender)
{
    int	windowstate;

    if (TextSetting)
    	TextForm->LocatePanel();

    if (Tag == 2) {
    	Tag = 1;
        return;
    }

    windowstate = (int)WindowState;
    if (windowstate != 0) {
    	RWindowState = windowstate;
        return;
    }

    if (RWindowState == 0) {
    	RLeft = Left;
        RTop = Top;
        RWidth = Width;
        RHeight = Height;
    }
    else if (RWindowState == 2) {
        Left = RLeft;
        Top = RTop;
        Width = RWidth;
        Height = RHeight;
    }

    RWindowState = windowstate;
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::OpenListFiles(void)
{
    int i;
    int count;
    AnsiString FileName;

    if (ListForm->SelectCount == 0)
    	return;

    if (ListForm->WindowState == wsMaximized)
    	ListForm->WindowState = wsNormal;

    for (i = 0, count = 0; i < ListForm->ListCount; i++) {
    	if (ListForm->ListIndex->Strings[i] == "+") {
			ViewForm = new TViewForm (0);

    		FileName = ListForm->ListDir + ListForm->ListFiles->Strings[i];
    		ViewForm->Open2(FileName);
            count++;
        }
    }

    if (DrawSetting && count > 0) {
    	ViewForm->SetDrawColor();
        ViewForm->Image1->Cursor = (TCursor)1;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::View1Click(TObject *Sender)
{
    int pos;
    AnsiString ListName;
    bool areasetting;
    bool textsetting;
    AnsiString OpenName;

    areasetting = AreaSetting;
    textsetting = TextSetting;

    if (ListSetting) {       // łɃt@C̈ꗗ\Ăꍇ
        ListForm->Close();
    }
    else {
    	if (textsetting)
    		ViewForm->Text1Click(Sender);
    	else if (areasetting)
    		ViewForm->Areasetting1Click(Sender);

    	if (RListDir != "")
    		OpenListDialog->InitialDir = RListDir;

    	OpenListDialog->FilterIndex = RListFileType;

    	if (OpenListDialog->Execute()) {
        	FrameForm->TimerOn = true;

        	ListSetting = true;
        	View1->Checked = true;
            SpeedButton3->Down = true;

			ListForm = new TListForm (this);

            ListForm->Show();
            if (ListForm->Tag == -1) {		// Error
            	ListForm->Close();
                ShowMessage("TlC̃TCY傫܂B");

                if (textsetting)
    				ViewForm->Text1Click(Sender);
    			else if (areasetting)
    				ViewForm->Areasetting1Click(Sender);

                FrameForm->TimerOn = false;
                return;
            }

        	ListForm->DispListFiles();

            ListName = OpenListDialog->FileName;
        	pos = ListName.Pos(ExtractFileName(ListName));
        	if (pos > 4)
        		pos--;
        	ListName.SetLength(pos - 1);

        	RListDir = ListName;
        	RListFileType = OpenListDialog->FilterIndex;

            if (ListForm->Active == false)
            	ListForm->SetFocus();

            FrameForm->TimerOn = false;
            if (ROverView)
            	OverViewForm->DrawListView();
        }
        else {
            SpeedButton3->Down = false;
        	if (textsetting)
    			ViewForm->Text1Click(Sender);
    		else if (areasetting)
    			ViewForm->Areasetting1Click(Sender);
    	}
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Size1Click(TObject *Sender)
{
    int Result;

	if (ListSetting)
    	ListForm->Size1Click(Sender);
    else {
    	SetListSize(Result);
        if (Result != mrOk)
        	return;
        View1Click(Sender);
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SetListSize(int &Result)
{
    int size, width;

    ListSizeForm = new TListSizeForm (this);

    Result = ListSizeForm->ShowModal();

    try {
    	size = StrToInt(ListSizeForm->Edit1->Text) - (ListSpace * 2);
    	width = StrToInt(ListSizeForm->Edit2->Text);
    }
    catch(...) {
    	delete ListSizeForm;
        if (Result == mrOk)
        	ShowMessage("͒l܂B");
        return;
    }

    delete ListSizeForm;

    if (Result != mrOk || ((size == RListSize) && (width == RMaxImageWidth)))
    	return;

    if (size < 40)
    	size = 40;
    else if (size > 5000)
    	size = 5000;

    if (width < 40 + ListSpace * 2)
    	width = 40 + ListSpace * 2;
    else if (width > 5000 + ListSpace * 2)
    	width = 5000 + ListSpace * 2;

    if (width < size + ListSpace * 2)
    	width = size + ListSpace * 2;

    RListSize = size;
    RMaxImageWidth = width;
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::WMDropFiles(TWMDropFiles Msg)
{
    int i, count;
    AnsiString FileName;
    char filename[256 + 2];

    count = DragQueryFile((HDROP)Msg.Drop, 0xFFFFFFFF, NULL, 255);

    for (i = 0; i < count; i++) {
        DragQueryFile((HDROP)Msg.Drop, i, filename, 255);
        FileName = filename;

    	ViewForm = new TViewForm (this);
        ViewForm->Open(FileName);
    }

    DragFinish((HDROP)Msg.Drop);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Opening(bool opening)
{
    bool TrueID;
    int Result;

    TRegistry *Reg = new TRegistry;

    Reg->RootKey = HKEY_CURRENT_USER;

    if (Reg->OpenKey("\\Software\\seizo\\Image Viewer", false)) {
	    RUserID = Reg->ReadInteger("RUserID");
	    RProgramID = Reg->ReadInteger("RProgramID");
    }
    else {
		RUserID = 0;
        RProgramID = 0;
    }

    delete Reg;

    TrueID = false;
    Result =  RProgramID - RUserID;

    switch (RUserID % 3) {
    	case 0:
        	if (Result == 19511201)
            	TrueID = true;
            break;
    	case 1:
        	if (Result == 261201)
            	TrueID = true;
            break;
    	case 2:
        	if (Result == 1121951)
            	TrueID = true;
            break;
        default:
        	break;
    }

    if (TrueID && opening)
    	return;

	OpeningForm = new TOpeningForm (this);

    OpeningForm->Show();

    Application->ProcessMessages();

    GetIDForm = new TGetIDForm (this);

    if (TrueID) {
		GetIDForm->Edit1->Text = IntToStr(RUserID);
        GetIDForm->Edit2->Text = IntToStr(RProgramID);
	}
    else {
    	GetIDForm->Edit1->Text = "";
        GetIDForm->Edit2->Text = "";
	}

    Result = GetIDForm->ShowModal();

    if (Result != mrOk) {
        if (!TrueID) {
    		RUserID = 0;
        	RProgramID = 0;
        }
    }
    else {
    	try {
        	RUserID = StrToInt(GetIDForm->Edit1->Text);
            RProgramID = StrToInt(GetIDForm->Edit2->Text);
        }
        catch(...) {
        	RUserID = 0;
        	RProgramID = 0;
        }
    }

    delete GetIDForm;

    if (Result != mrOk) {
    	OpeningForm->Close();
        return;
    }

    TrueID = false;
    Result =  RProgramID - RUserID;

    switch (RUserID % 3) {
    	case 0:
        	if (Result == 19511201)
            	TrueID = true;
            break;
    	case 1:
        	if (Result == 261201)
            	TrueID = true;
            break;
    	case 2:
        	if (Result == 1121951)
            	TrueID = true;
            break;
        default:
        	break;
    }

    if (TrueID)
    	ShowMessage("o^L܂BNI[vjÕ_CAO\ȂlɂȂ܂B");
    else {
    	RUserID = 0;
        RProgramID = 0;
        ShowMessage("ID ԍႢ܂BpgṕAo^ĉB");
    }

    OpeningForm->Close();
}
//---------------------------------------------------------------------------
bool __fastcall TFrameForm::SusieView(AnsiString FileName, Graphics::TBitmap *Bitmap)
{
    int i, rc;
    int Fhnd;
    HLOCAL hBm, hBInfo;
    BITMAPINFO *BInfo;
    void *Data;
	PictureInfo PicInf;

    Fhnd = FileOpen(FileName, fmOpenRead);
    if (Fhnd == -1)
    	return(false);

    for (i = 0; i < PluginCount; i++) {
    	hInstSPI = LoadLibrary(PluginFiles->Strings[i].c_str());
        if (hInstSPI == 0)
        	continue;

        FileSeek(Fhnd, 0, 0);

        try {
        	IsSupported = (PROCISSUPPORTED)GetProcAddress(hInstSPI, "IsSupported");
        	rc = IsSupported(FileName.c_str(), Fhnd);
        }
        catch(...) {
        	rc = 0;
        }

        if (rc != 0) {
        	FileClose(Fhnd);

            try {
            	GetPictureInfo = (PROCGETPICTUREINFO)GetProcAddress(hInstSPI, "GetPictureInfo");
            	rc = GetPictureInfo(FileName.c_str(), 0, 0, &PicInf);
            }
            catch(...) {
            	rc = -1;
            }

            if (rc == 0) {
                try {
            		GetPicture = (PROCGETPICTURE)GetProcAddress(hInstSPI, "GetPicture");
            		rc = GetPicture(FileName.c_str(), 0, 0, &hBInfo, &hBm, NULL, 0);
                }
                catch(...) {
                	rc = -1;
                }

            	if (rc == 0) {
            		BInfo = (BITMAPINFO *)LocalLock(hBInfo);
            		Data = LocalLock(hBm);

            		Bitmap->Width = PicInf.width;
            		Bitmap->Height = PicInf.height;

                    try {
            			SetDIBits(Bitmap->Canvas->Handle, Bitmap->Handle, 0,
                    	 BInfo->bmiHeader.biHeight, Data, BInfo, DIB_RGB_COLORS);
                    }
                    catch(...) {
                    	rc = -1;
                    }

            		LocalUnlock(hBm);
            		LocalFree(hBm);
            		LocalUnlock(hBInfo);
            		LocalFree(hBInfo);
                }
            }

            FreeLibrary(hInstSPI);

            if (rc == 0)
            	return(true);
            else
            	return(false);
        }

        FreeLibrary(hInstSPI);
    }

    FileClose(Fhnd);

    return(false);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SusieCheck(void)
{
    BOOL Done;
    AnsiString Plugin;
    HANDLE hFindFile;
    DWORD Attrib;
    WIN32_FIND_DATA FindData;

    PluginCount = 0;
    PluginFiles->Clear();

    Plugin = SystemRoot + "\\System\\*.spi";

    hFindFile = FindFirstFile(Plugin.c_str(), &FindData);

    if (hFindFile == INVALID_HANDLE_VALUE)
    	return;

    Done = FALSE;

    while (!Done) {
    	Plugin = FindData.cFileName;
        Attrib = FindData.dwFileAttributes;

        if (!(Attrib & FILE_ATTRIBUTE_DIRECTORY)) {
        	PluginFiles->Add(Plugin);
            PluginCount++;
        }

        Done = !(FindNextFile(hFindFile, &FindData));
    }

    FindClose(hFindFile);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton1Click(TObject *Sender)
{
	New1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton2Click(TObject *Sender)
{
	Open1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton3Click(TObject *Sender)
{
	View1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton22Click(TObject *Sender)
{
	Panel1->Visible = false;
    Speed1->Checked = false;
    RMenuSpeedBar = false;

    if (TextSetting)
    	TextForm->LocatePanel();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Speed1Click(TObject *Sender)
{
	if (Panel1->Visible == true) {
    	Panel1->Visible = false;
        Speed1->Checked = false;
        RMenuSpeedBar = false;
    }
    else {
        if (RDrawSpeedBar)
        	Panel2->Visible = false;

    	Panel1->Visible = true;
        Speed1->Checked = true;
        RMenuSpeedBar = true;

        if (RDrawSpeedBar)
        	Panel2->Visible = true;
    }

    if (TextSetting)
    	TextForm->LocatePanel();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton4Click(TObject *Sender)
{
	Size1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton5Click(TObject *Sender)
{
	ViewForm->Close1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton6Click(TObject *Sender)
{
	ViewForm->Save1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton7Click(TObject *Sender)
{
	ViewForm->Copy1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton8Click(TObject *Sender)
{
	ViewForm->Move1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton9Click(TObject *Sender)
{
	ViewForm->Rename1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton10Click(TObject *Sender)
{
	ViewForm->Delete1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton11Click(TObject *Sender)
{
	ViewForm->Print2Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton12Click(TObject *Sender)
{
	ViewForm->Preview1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton13Click(TObject *Sender)
{
	ViewForm->Setup1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton14Click(TObject *Sender)
{
	Operation1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton15Click(TObject *Sender)
{
    ViewForm->Areasetting1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton16Click(TObject *Sender)
{
	ViewForm->Text1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton17Click(TObject *Sender)
{
	ViewForm->Areacolor1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton18Click(TObject *Sender)
{
	ViewForm->Copytoclipboard1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton19Click(TObject *Sender)
{
	ViewForm->Cuttoclipboard1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton20Click(TObject *Sender)
{
	ViewForm->Pastefromclipboard1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::OnIdle(TObject *Sender, bool &Done)
{
	bool chk;

    if (TimerOn || SpeedButton5->Enabled == false)
    	return;
    
    if (ViewForm == NULL || ViewForm->Active == false)
    	return;

    chk = (!TextSetting && Clipboard()->HasFormat(CF_BITMAP));
    SpeedButton20->Enabled = chk;
    ViewForm->Pastefromclipboard1->Enabled = chk;
    SpeedButton21->Enabled = chk;
    ViewForm->Clearclipboard1->Enabled = chk;

    chk = (AreaSetting && chk);
    SpeedButton45->Enabled = chk;
    ViewForm->Pastewithlocation1->Enabled = chk;
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton23Click(TObject *Sender)
{
	ViewForm->Original1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton24Click(TObject *Sender)
{
	ViewForm->Originalimage1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton25Click(TObject *Sender)
{
	ViewForm->Stretch1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton26Click(TObject *Sender)
{
	ViewForm->Wallpaper1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::OpenListFile(AnsiString FileName)
{
    if (ListForm->WindowState == wsMaximized)
    	ListForm->WindowState = wsNormal;

    ViewForm = new TViewForm (0);

    ViewForm->Open2(FileName);

    if (DrawSetting) {
    	ViewForm->SetDrawColor();
        ViewForm->Image1->Cursor = (TCursor)1;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton21Click(TObject *Sender)
{
	ViewForm->Clearclipboard1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton27Click(TObject *Sender)
{
	ViewForm->Revers1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton28Click(TObject *Sender)
{
	ViewForm->N901Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton29Click(TObject *Sender)
{
	ViewForm->N1801Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton30Click(TObject *Sender)
{
	ViewForm->N2701Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton31Click(TObject *Sender)
{
	ViewForm->Bright1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton32Click(TObject *Sender)
{
	ViewForm->Contrast1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton33Click(TObject *Sender)
{
	ViewForm->Sobel1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton34Click(TObject *Sender)
{
	ViewForm->PaintSobel1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton35Click(TObject *Sender)
{
	ViewForm->Edge1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton36Click(TObject *Sender)
{
	ViewForm->Flat1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton37Click(TObject *Sender)
{
	ViewForm->Median1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton38Click(TObject *Sender)
{
	ViewForm->Posterisation1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton39Click(TObject *Sender)
{
	ViewForm->Mosaic1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton40Click(TObject *Sender)
{
	ViewForm->Negative1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton41Click(TObject *Sender)
{
	ViewForm->MonoColor1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton42Click(TObject *Sender)
{
	ViewForm->Framing1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton43Click(TObject *Sender)
{
	Histgram1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton44Click(TObject *Sender)
{
	Control1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::ActiveSpeedBar(void)
{
    if (SpeedButton5->Enabled == true)
    	return;

	SpeedButton5->Enabled = true;
    SpeedButton6->Enabled = true;
	SpeedButton7->Enabled = true;
    SpeedButton8->Enabled = true;
	SpeedButton9->Enabled = true;
    SpeedButton10->Enabled = true;
	SpeedButton11->Enabled = true;
    SpeedButton12->Enabled = true;
	SpeedButton13->Enabled = true;
    SpeedButton15->Enabled = true;
    SpeedButton16->Enabled = true;
    SpeedButton18->Enabled = true;
    SpeedButton19->Enabled = true;
    SpeedButton23->Enabled = true;
    SpeedButton24->Enabled = true;
    SpeedButton25->Enabled = true;
    SpeedButton26->Enabled = true;
    SpeedButton27->Enabled = true;
    SpeedButton28->Enabled = true;
    SpeedButton29->Enabled = true;
    SpeedButton30->Enabled = true;
    SpeedButton31->Enabled = true;
    SpeedButton32->Enabled = true;
    SpeedButton33->Enabled = true;
    SpeedButton34->Enabled = true;
    SpeedButton35->Enabled = true;
    SpeedButton36->Enabled = true;
    SpeedButton37->Enabled = true;
    SpeedButton38->Enabled = true;
    SpeedButton39->Enabled = true;
    SpeedButton40->Enabled = true;
    SpeedButton41->Enabled = true;
    SpeedButton42->Enabled = true;
    SpeedButton46->Enabled = true;
    SpeedButton49->Enabled = true;
    SpeedButton50->Enabled = true;
    SpeedButton51->Enabled = true;
    SpeedButton52->Enabled = true;
    SpeedButton53->Enabled = true;
    SpeedButton54->Enabled = true;
    SpeedButton55->Enabled = true;
    SpeedButton56->Enabled = true;
    SpeedButton57->Enabled = true;
    SpeedButton59->Enabled = true;
    SpeedButton60->Enabled = true;
    SpeedButton61->Enabled = true;
    SpeedButton63->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::DeactiveSpeedBar(void)
{
    if (SpeedButton5->Enabled == false)
    	return;

	SpeedButton5->Enabled = false;
    SpeedButton6->Enabled = false;
    SpeedButton7->Enabled = false;
    SpeedButton8->Enabled = false;
	SpeedButton9->Enabled = false;
    SpeedButton10->Enabled = false;
	SpeedButton11->Enabled = false;
    SpeedButton12->Enabled = false;
	SpeedButton13->Enabled = false;
    SpeedButton15->Enabled = false;
    SpeedButton16->Enabled = false;
    SpeedButton18->Enabled = false;
    SpeedButton19->Enabled = false;
    SpeedButton20->Enabled = false;
    SpeedButton21->Enabled = false;
    SpeedButton23->Enabled = false;
    SpeedButton24->Enabled = false;
    SpeedButton25->Enabled = false;
    SpeedButton26->Enabled = false;
    SpeedButton27->Enabled = false;
    SpeedButton28->Enabled = false;
    SpeedButton29->Enabled = false;
    SpeedButton30->Enabled = false;
    SpeedButton31->Enabled = false;
    SpeedButton32->Enabled = false;
    SpeedButton33->Enabled = false;
    SpeedButton34->Enabled = false;
    SpeedButton35->Enabled = false;
    SpeedButton36->Enabled = false;
    SpeedButton37->Enabled = false;
    SpeedButton38->Enabled = false;
    SpeedButton39->Enabled = false;
    SpeedButton40->Enabled = false;
    SpeedButton41->Enabled = false;
    SpeedButton42->Enabled = false;
    SpeedButton45->Enabled = false;
    SpeedButton46->Enabled = false;
    SpeedButton47->Enabled = false;
    SpeedButton49->Enabled = false;
    SpeedButton50->Enabled = false;
    SpeedButton51->Enabled = false;
    SpeedButton52->Enabled = false;
    SpeedButton53->Enabled = false;
    SpeedButton54->Enabled = false;
    SpeedButton55->Enabled = false;
    SpeedButton56->Enabled = false;
    SpeedButton57->Enabled = false;
    SpeedButton59->Enabled = false;
    SpeedButton60->Enabled = false;
    SpeedButton61->Enabled = false;
    SpeedButton63->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton45Click(TObject *Sender)
{
	ViewForm->Pastewithlocation1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton46Click(TObject *Sender)
{
	ViewForm->MakeBlank1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::InitUndoData(void)
{
	int i;

    UndoCount = 0;

    for (i = 0; i < RMaxUndoCount; i++) {
        Undo[i].Width = 0;
        Undo[i].Height = 0;
        Undo[i].Save = false;
        Undo[i].Modefied = false;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton47Click(TObject *Sender)
{
	ViewForm->Undo1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::EnableUndo1Click(TObject *Sender)
{
    int count;

    count = MDIChildCount;
    if (ListSetting)
    	count--;

    if (RCanUndo) {
		RCanUndo = false;
        EnableUndo1->Checked = false;
        EnableUndo1->Caption = "޳L(&E)";
        if (SpeedButton48->Down == true)
        	SpeedButton48->Down = false;
        SpeedButton48->Hint = "޳Lɂ";
    	InitUndoData();
    	SpeedButton47->Enabled = false;

    	if (count > 0 && ViewForm->Active)
    		ViewForm->Undo1->Enabled = false;
    }
    else {
    	RCanUndo = true;
        EnableUndo1->Checked = true;
        EnableUndo1->Caption = "޳𖳌(&E)";
        if (SpeedButton48->Down == false)
        	SpeedButton48->Down = true;
        SpeedButton48->Hint = "޳𖳌ɂ";
        InitUndoData();

        if (count > 0 && ViewForm->Active) {
        	if (AreaSetting)
        		ViewForm->ClearArea();
    		ViewForm->StoreUndoBitmap(true);
        	if (AreaSetting) {
        		ViewForm->DrawArea();
        		if (TextSetting) {
        			TextForm->DrawText();
            		TextForm->DrawRing();
        		}
    		}
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton48Click(TObject *Sender)
{
	EnableUndo1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton58Click(TObject *Sender)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    DrawSettingOff();

	Panel2->Visible = false;
    Speed2->Checked = false;
    RDrawSpeedBar = false;

    if (TextSetting)
    	TextForm->LocatePanel();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Speed2Click(TObject *Sender)
{
	if (Panel2->Visible == true) {
        SpeedButton58Click(Sender);
    }
    else {
        DrawSetting = false;
    	Drawing = false;

    	Panel2->Visible = true;
        Speed2->Checked = true;
        RDrawSpeedBar = true;
    }

    if (TextSetting)
    	TextForm->LocatePanel();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::UpDown1Click(TObject *Sender, TUDBtnType Button)
{
    if (TimerOn)
    	return;				// ˂Ԃ

    DrawWidth = UpDown1->Position;

    Image1->Canvas->Brush->Color = clWhite;
    Image1->Canvas->Brush->Style = bsSolid;
    Image1->Canvas->FillRect(Rect(0, 0, 31, 21));

    Image1->Canvas->Pen->Color = clBlack;
    Image1->Canvas->Pen->Width = DrawWidth;
    Image1->Canvas->MoveTo(0, 11);
    Image1->Canvas->LineTo(30, 11);

    if (SpeedButton49->Enabled)
    	ViewForm->SetDrawColor();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Panel3MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    if (Button == mbLeft) {
		DrawColor = clBlue;
    	Panel3->Color = clBlue;
    }
    else if (Button == mbRight) {
        if (DrawIn == false)
        	DrawColor = clBtnFace;
        else
            DrawColor = DrawInColor;

        Panel3->Color = DrawColor;
    }

    Panel7->Color = Panel3->Color;
    Panel7->Update();
    DispRGB(true);

    if (SpeedButton49->Enabled)
    	ViewForm->SetDrawColor();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Panel4MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (TimerOn)
    	return;				// ˂Ԃ

    if (Button == mbLeft) {
		DrawInColor = clBtnFace;
    	DrawIn = false;
    	Panel4->Color = clBtnFace;
    }
    else if (Button == mbRight) {
    	DrawInColor = DrawColor;
        DrawIn = true;
        Panel4->Color = DrawInColor;
    }

    Panel7->Color = Panel4->Color;
    Panel7->Update();
    DispRGB(DrawIn);

    if (SpeedButton49->Enabled)
    	ViewForm->SetDrawColor();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Button1Click(TObject *Sender)
{
    if (TimerOn)
    	return;				// ˂Ԃ

    ColorDialog1->Color = Panel3->Color;

	if (ColorDialog1->Execute()) {
    	Panel3->Color = ColorDialog1->Color;
        DrawColor = Panel3->Color;

        Panel7->Color = Panel3->Color;
        Panel7->Update();
        DispRGB(true);

        if (SpeedButton49->Enabled)
    		ViewForm->SetDrawColor();
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Button2Click(TObject *Sender)
{
    if (TimerOn)
    	return;				// ˂Ԃ

    ColorDialog1->Color = Panel4->Color;

	if (ColorDialog1->Execute()) {
    	Panel4->Color = ColorDialog1->Color;
        DrawInColor = Panel4->Color;

        Panel7->Color = Panel4->Color;
        Panel7->Update();
        DispRGB(true);

    	if (SpeedButton49->Enabled)
    		ViewForm->SetDrawColor();

        DrawIn = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Image1MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (TimerOn)
    	return;				// ˂Ԃ

	DrawWidth = 1;
    UpDown1->Position = 1;
    UpDown1Click(Sender, btNext);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton49Click(TObject *Sender)
{
    if (TimerOn)			// ׂ́A49`56, 63 ׂ݂\ĂB
    	return;				// ˂Ԃ

    if (((TSpeedButton *)Sender)->Down) {
    	DrawTool = ((TSpeedButton *)Sender)->Tag;
    	if (DrawSetting == false) {
        	DrawSetting = true;
            Drawing = false;

            if (TextSetting)
    			ViewForm->Text1Click(Sender);
    		else if (AreaSetting)
    			ViewForm->Areasetting1Click(Sender);
        }
        ViewForm->SetDrawColor();

        ViewForm->Image1->Cursor = (TCursor)1;
    }
    else {
    	DrawSetting = false;
        Drawing = false;

        ViewForm->Image1->Cursor = crDefault;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::DrawSettingOff(void)
{
    DrawSetting = false;
    Drawing = false;

    switch (DrawTool) {
    	case	49:
        	SpeedButton49->Down = false;
            break;
    	case	50:
        	SpeedButton50->Down = false;
            break;
    	case	51:
        	SpeedButton51->Down = false;
            break;
    	case	52:
        	SpeedButton52->Down = false;
            break;
    	case	53:
        	SpeedButton53->Down = false;
            break;
    	case	54:
        	SpeedButton54->Down = false;
            break;
    	case	55:
        	SpeedButton55->Down = false;
            break;
    	case	56:
        	SpeedButton56->Down = false;
            break;
    	case	57:
        	SpeedButton57->Down = false;
            break;
    	case	63:
        	SpeedButton63->Down = false;
            break;
    	default:
            break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Image2MouseMove(TObject *Sender, TShiftState Shift,
	int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    Panel7->Color = Image2->Canvas->Pixels[X][Y];
    Panel7->Update();
    DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Image2MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	TColor color;

    if (TimerOn)
    	return;				// ˂Ԃ

    color = Image2->Canvas->Pixels[X][Y];

    if (Button == mbLeft) {
    	Panel3->Color = color;
        DrawColor = color;
    }
    else if (Button == mbRight) {
    	Panel4->Color = color;
        DrawInColor = color;
        DrawIn = true;
    }

    Panel7->Color = color;
    Panel7->Update();
    DispRGB(true);

    if (SpeedButton49->Enabled)
    	ViewForm->SetDrawColor();
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Readme1Click(TObject *Sender)
{
    int	pos, len;
	AnsiString FileName;
    AnsiString Ext;

    FileName = Application->ExeName;
    Ext = ExtractFileName(FileName);
    pos = FileName.Pos(Ext);
    len = Ext.Length();
    FileName.Delete(pos, len);
    FileName += "Readme.txt";

	spawnlp(P_NOWAIT, "NOTEPAD.EXE", "NOTEPAD.EXE", FileName.c_str(), NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton59Click(TObject *Sender)
{
	ViewForm->RGB1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton60Click(TObject *Sender)
{
	ViewForm->Reduce1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Panel3MouseMove(TObject *Sender, TShiftState Shift,
	int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    Panel7->Color = Panel3->Color;
    Panel7->Update();
    DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Panel4MouseMove(TObject *Sender, TShiftState Shift,
	int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    Panel7->Color = Panel4->Color;
    Panel7->Update();
    DispRGB(DrawIn);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::DispRGB(bool Disp)
{
	int color;
    int red, green, blue;
    int ch;
    char hex[8];

    if (!Disp) {
    	Label4->Caption = "";
        Label5->Caption = "";
        Label6->Caption = "";

        return;
    }

	color = Panel7->Color;
    red = color & 0x000000ff;				// Red
    green = (color & 0x0000ff00) >> 8;		// Green
    blue = (color & 0x00ff0000) >> 16;		// Blue

    if (HexRGB) {							// 16i\
    	ch = red / 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[0] = (char)ch;
    	ch = red % 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[1] = (char)ch;
    	hex[2] = 'H';
        hex[3] ='\0';
        Label4->Caption = hex;

    	ch = green / 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[0] = (char)ch;
    	ch = green % 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[1] = (char)ch;
    	hex[2] = 'H';
        hex[3] ='\0';
        Label5->Caption = hex;

    	ch = blue / 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[0] = (char)ch;
    	ch = blue % 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[1] = (char)ch;
    	hex[2] = 'H';
        hex[3] ='\0';
        Label6->Caption = hex;
    }
    else {
    	Label4->Caption = IntToStr(red);
        Label5->Caption = IntToStr(green);
        Label6->Caption = IntToStr(blue);
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Panel8MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Label1MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Label2MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Label3MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Label4MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Label5MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Label6MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (TimerOn)
    	return;				// ˂Ԃ

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton61Click(TObject *Sender)
{
	ViewForm->Triming1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::OverView1Click(TObject *Sender)
{
	if (ROverView) {
    	OverViewForm->Close();
    }
    else {
    	OverViewForm = new TOverViewForm (Application);
    	OverViewForm->Show();
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::SpeedButton62Click(TObject *Sender)
{
	OverView1Click(Sender);	
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Histgram1Click(TObject *Sender)
{
	if (RHistgram) {
    	HistgramForm->Close();
    }
    else {
    	HistgramForm = new THistgramForm (Application);
    	HistgramForm->Show();
    }
}
//---------------------------------------------------------------------------
void __fastcall TFrameForm::Control1Click(TObject *Sender)
{
    int count;

    count = MDIChildCount;
    if (ListSetting) {
    	count--;
    	if (ListForm->WindowState == wsMaximized)
    		ListForm->WindowState = wsNormal;
    }

    if (count > 0) {
    	if (ViewForm->WindowState == wsMaximized)
    		ViewForm->WindowState = wsNormal;

    	if (TextSetting)
    		ViewForm->Text1Click(Sender);
    	else if (AreaSetting)
    		ViewForm->Areasetting1Click(Sender);
    }

    ControlForm = new TControlForm (this);

    ControlForm->ShowModal();

    delete ControlForm;
}
//---------------------------------------------------------------------------
