//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\printers.hpp>
#pragma hdrstop

#include "MdiPreview.h"
#include "MdiView.h"
#include "MdiFrame.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPreviewForm *PreviewForm;
//---------------------------------------------------------------------------
__fastcall TPreviewForm::TPreviewForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::FormCreate(TObject *Sender)
{
    int left, temp;

    FrameForm->preview = true;

    Bitmap = new Graphics::TBitmap;

    Swidth = ViewForm->Image1->Width * FrameForm->RPrintRatio / 100 / FrameForm->rr;
    Sheight = ViewForm->Image1->Height * FrameForm->RPrintRatio / 100 / FrameForm->rr;

    Bitmap->Width = ViewForm->Image1->Picture->Bitmap->Width / 4;
    Bitmap->Height = ViewForm->Image1->Picture->Bitmap->Height / 4;

    Bitmap->Canvas->StretchDraw(Rect(0, 0, Bitmap->Width - 1, Bitmap->Height - 1),
     ViewForm->Image1->Picture->Bitmap);

    Image2->Width = FrameForm->rx + 10;
    Image2->Height = FrameForm->ry + 10;

    ClientWidth = FrameForm->rx + 10;
    ClientHeight = FrameForm->ry + 10 + 80;

    if (ClientWidth < 144)
    	ClientWidth = 144;

    left = ClientWidth;

    if (left > 144) {
    	if (left < 160) {
        	left = (left - 57 * 2 - 15) / 2;
            Button2->Left = left + 57 + 15;
        }
        else {
        	left = (left - 57 * 2 - 20) / 2;
            Button2->Left = left + 57 + 20;
        }

        Button1->Left = left;
        Button3->Left = left;
        Edit1->Left = Button2->Left;
        UpDown1->Left = Edit1->Left + 35;
        Label1->Left = UpDown1->Left + 21;
    }

    if (FrameForm->psw) {
    	ViewForm->TurnBitmap(Bitmap, 90);
        temp = Swidth;
        Swidth = Sheight;
        Sheight = temp;
    }

    Preview();
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::Preview(void)
{
    int lx, ly;
    int rx, ry;

    lx = FrameForm->Lx;
    ly = FrameForm->Ly;
    rx = FrameForm->rx;
    ry = FrameForm->ry;

    if (FrameForm->psw)
    	lx -= Swidth - 1;

	Image2->Canvas->Brush->Color = clWhite;
    Image2->Canvas->FillRect(Rect(5, 5, 5 + rx, 5 + ry));

    Image2->Canvas->StretchDraw(Rect(5 + lx, 5 + ly, 5 + lx + Swidth - 1,
     5 + ly + Sheight - 1), Bitmap);

    Image2->Canvas->Brush->Color = clBtnFace;
    Image2->Canvas->FillRect(Rect(0, 0, 5, 5 + ry + 5));
    Image2->Canvas->FillRect(Rect(0, 0, 5 + rx + 5, 5));
    Image2->Canvas->FillRect(Rect(5 + rx, 0, 5 + rx + 5, 5 + ry + 5));
    Image2->Canvas->FillRect(Rect(0, 5 + ry, 5 + rx + 5, 5 + ry + 5));

    Image2->Canvas->Pen->Width = 1;
    Image2->Canvas->Pen->Color = clWhite;
    Image2->Canvas->MoveTo(5 - 1, 5 + ry);
    Image2->Canvas->LineTo(5 - 1, 5 - 1);
    Image2->Canvas->LineTo(5 + rx, 5 - 1);
    Image2->Canvas->Pen->Color = clBlack;
    Image2->Canvas->LineTo(5 + rx, 5 + ry);
    Image2->Canvas->LineTo(5, 5 + ry);
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	delete Bitmap;
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::Image2MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	FrameForm->Lx = X - 5;
    FrameForm->Ly = Y - 5;

    Preview();
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::FormDestroy(TObject *Sender)
{
	FrameForm->preview = false;
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::FormShow(TObject *Sender)
{
	Edit1->Text = IntToStr(FrameForm->RPrintRatio);
}
//---------------------------------------------------------------------------
void __fastcall TPreviewForm::Button3Click(TObject *Sender)
{
    int ratio, temp;

    try {
    	ratio = StrToInt(Edit1->Text);
    }
    catch(...) {
    	ShowMessage("͒l܂B");
        Edit1->Text = IntToStr(FrameForm->RPrintRatio);
        return;
    }

    if (ratio < 2) {
    	ratio = 2;
        Edit1->Text = IntToStr(ratio);
    }
    else if (ratio > 200) {
    	ratio = 200;
        Edit1->Text = IntToStr(ratio);
    }

    Swidth = ViewForm->Image1->Width * ratio / 100 / FrameForm->rr;
    Sheight = ViewForm->Image1->Height * ratio / 100 / FrameForm->rr;

    if (FrameForm->psw) {
        temp = Swidth;
        Swidth = Sheight;
        Sheight = temp;
    }

    Preview();

    FrameForm->RPrintRatio = ratio;
}
//---------------------------------------------------------------------------
