//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MonoColor.h"
#include "MdiFrame.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMonoColorForm *MonoColorForm;
//---------------------------------------------------------------------------
__fastcall TMonoColorForm::TMonoColorForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Image1MouseMove(TObject *Sender,
	TShiftState Shift, int X, int Y)
{
    if (Monochrome)
    	return;

    Panel4->Color = Image1->Canvas->Pixels[X][Y];
    Panel4->Update();
    DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Image1MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	TColor color;

    if (Monochrome)
    	return;

    color = Image1->Canvas->Pixels[X][Y];

    Panel5->Color = color;
    MonoColor = color;

    Panel4->Color = color;
    Panel4->Update();
    DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::DispRGB(bool Disp)
{
	int color;
    int red, green, blue;
    int ch;
    char hex[8];

    if (!Disp) {
    	Label4->Caption = "";
        Label5->Caption = "";
        Label6->Caption = "";

        return;
    }

	color = Panel4->Color;
    red = color & 0x000000ff;				// Red
    green = (color & 0x0000ff00) >> 8;		// Green
    blue = (color & 0x00ff0000) >> 16;		// Blue

    if (HexRGB) {							// 16i\
    	ch = red / 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[0] = (char)ch;
    	ch = red % 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[1] = (char)ch;
    	hex[2] = 'H';
        hex[3] ='\0';
        Label4->Caption = hex;

    	ch = green / 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[0] = (char)ch;
    	ch = green % 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[1] = (char)ch;
    	hex[2] = 'H';
        hex[3] ='\0';
        Label5->Caption = hex;

    	ch = blue / 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[0] = (char)ch;
    	ch = blue % 16 + '0';
        if (ch > '9')
        	ch += 'A' - ':';
        hex[1] = (char)ch;
    	hex[2] = 'H';
        hex[3] ='\0';
        Label6->Caption = hex;
    }
    else {
    	Label4->Caption = IntToStr(red);
        Label5->Caption = IntToStr(green);
        Label6->Caption = IntToStr(blue);
    }
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Panel3MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Monochrome)
    	return;

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Button1Click(TObject *Sender)
{
    if (Monochrome)
    	return;

    ColorDialog1->Color = Panel5->Color;

	if (ColorDialog1->Execute()) {
    	Panel5->Color = ColorDialog1->Color;
        MonoColor = Panel5->Color;

        Panel4->Color = Panel5->Color;
        Panel4->Update();
        DispRGB(true);
    }
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::RadioButton1Click(TObject *Sender)
{
	Monochrome = true;
    Panel5->Color = clBtnFace;
    Panel4->Color = clBtnFace;
    Panel4->Update();
    DispRGB(false);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::RadioButton2Click(TObject *Sender)
{
	Monochrome = false;
    Panel5->Color = MonoColor;
    Panel4->Color = MonoColor;
    Panel4->Update();
    DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::FormShow(TObject *Sender)
{
	(int)MonoColor = FrameForm->RMonoColor;
    Monochrome = FrameForm->RMonochrome;
    HexRGB = false;

    if (Monochrome) {
		RadioButton1->Checked = true;
        Panel5->Color = clBtnFace;
    	Panel4->Color = clBtnFace;
    	Panel4->Update();
    	DispRGB(false);
    }
    else {
		RadioButton2->Checked = true;
        Panel5->Color = MonoColor;
    	Panel4->Color = MonoColor;
    	Panel4->Update();
    	DispRGB(true);
    }
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	if (ModalResult == mrOk) {
    	FrameForm->RMonoColor = (int)MonoColor;
        FrameForm->RMonochrome = Monochrome;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Panel5MouseMove(TObject *Sender,
	TShiftState Shift, int X, int Y)
{
	if (Monochrome)
    	return;

    Panel4->Color = Panel5->Color;
    Panel4->Update();
    DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Label1MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Monochrome)
    	return;

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Label2MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Monochrome)
    	return;

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Label3MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Monochrome)
    	return;

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Label4MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Monochrome)
    	return;

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Label5MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Monochrome)
    	return;

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------
void __fastcall TMonoColorForm::Label6MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Monochrome)
    	return;

    if (HexRGB)
    	HexRGB = false;
    else
    	HexRGB = true;

    if (Label4->Caption != "")
    	DispRGB(true);
}
//---------------------------------------------------------------------------