//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "ImageKit.h"
#include "ImgkDef.h"

#include "Opening.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOpeningForm *OpeningForm;
//---------------------------------------------------------------------------
__fastcall TOpeningForm::TOpeningForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TOpeningForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TOpeningForm::FormShow(TObject *Sender)
{
	int	pos, len;
    int width, height;
	AnsiString FileName;
    AnsiString Ext;
	AnsiString DateStr;
    TFontStyles fs;
    HANDLE Handle;
    FILE_INFO FT;

    FileName = Application->ExeName;
    Ext = ExtractFileName(FileName);
    pos = FileName.Pos(Ext);
    len = Ext.Length();
    FileName.Delete(pos, len);
    FileName += "Image";

    DateStr = FormatDateTime("yyyy'/'mm'/'dd'('aaaa') 'hh':'nn':'ss", Now());

    if (DateStr.Pos("j") != 0)
    	FileName += "0.jpg";
    else if (DateStr.Pos("j") != 0)
    	FileName += "1.jpg";
    else if (DateStr.Pos("Ηj") != 0)
    	FileName += "2.jpg";
    else if (DateStr.Pos("j") != 0)
    	FileName += "3.jpg";
    else if (DateStr.Pos("ؗj") != 0)
    	FileName += "4.jpg";
    else if (DateStr.Pos("j") != 0)
    	FileName += "5.jpg";
    else if (DateStr.Pos("yj") != 0)
    	FileName += "6.jpg";

    if (ImgKitFileType(FileName.c_str(), &FT))
    	Handle = ImgKitFileLoad(FileName.c_str(), "", "");
    else
    	Handle = 0;

    if (Handle == 0) {
        Close();
        return;
    }
    else {
        width = FT.Width;
        height = FT.Height;

    	Image1->Width = width;
    	Image1->Height = height;

    	Image1->Picture->Bitmap->Width = width;
    	Image1->Picture->Bitmap->Height = height;

    	if (width < 104) {
    		width = 104;
        	height = width * Image1->Height / Image1->Width;
    	}

        width += 4;
        height += 4;

        ClientWidth = width;
        ClientHeight = height;

    	ImgKitDisplayHdc(Image1->Canvas->Handle, Handle, FT.Width, FT.Height, false);
    	ImgKitMemFree(Handle);
    }

    fs << fsItalic;

    Image1->Canvas->Brush->Style = bsClear;
	Image1->Canvas->Font->Style = fs;
    Image1->Canvas->Font->Color = clWhite;
    Image1->Canvas->Font->Size = 16;

    Image1->Canvas->TextOut(10, 10, "Image Viewer Version 2.00");

    Image1->Canvas->TextOut(10, Image1->Height - 30, DateStr);

    AutoScroll = true;
}
//---------------------------------------------------------------------------