//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "OverView.h"
#include "MdiFrame.h"
#include "MdiView.h"
#include "MdiList.h"
#include "Text.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOverViewForm *OverViewForm;
//---------------------------------------------------------------------------
__fastcall TOverViewForm::TOverViewForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TOverViewForm::SetFormSize(void)
{
	if (FrameForm->RovWidth < 110)
    	FrameForm->RovWidth = 110;
    else if (FrameForm->RovWidth > 310)
    	FrameForm->RovWidth = 310;

	if (FrameForm->RovHeight < 110)
    	FrameForm->RovHeight = 110;
    else if (FrameForm->RovHeight > 310)
    	FrameForm->RovHeight = 310;

    ClientWidth = FrameForm->RovWidth;
    ClientHeight = FrameForm->RovHeight;
}
//---------------------------------------------------------------------------
void __fastcall TOverViewForm::DrawOverView(void)
{
    int count;
	int width, height;
    int owidth, oheight;
    bool err;

    if (FrameForm->TimerOn)
    	return;

    count = FrameForm->MDIChildCount;
    if (FrameForm->ListSetting)
    	count--;

    if (count == 0)
		return;

    err = false;

    try {
    	width = ViewForm->Image1->Width;
        height = ViewForm->Image1->Height;
    }
    catch (...) {
    	err = true;
    }

    if (err)
    	return;

    owidth = ClientWidth - 10;
    oheight = ClientHeight - 10;

    if (width <= owidth && height <= oheight) {
    	owidth = width;
        oheight = height;
    }
    else if (width >= height) {
    	oheight = owidth * height / width;
    }
    else {
    	owidth = oheight * width / height;
    }

    Image1->Left = (ClientWidth - owidth) / 2;
    Image1->Top = (ClientHeight - oheight) / 2;
    Image1->Width = owidth;
    Image1->Height = oheight;
    Image1->Picture->Bitmap->Width = owidth;
    Image1->Picture->Bitmap->Height = oheight;
    Image1->Canvas->StretchDraw(Rect(0, 0, owidth, oheight),
     ViewForm->Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TOverViewForm::DrawListView(void)
{
	int width, height;
    int owidth, oheight;
    bool err;

    if (FrameForm->TimerOn)
    	return;

    if (FrameForm->MDIChildCount == 0 || FrameForm->ListSetting == false)
		return;

    err = false;

    try {
    	width = ListForm->Image1->Width;
        height = ListForm->Image1->Height;
    }
    catch (...) {
    	err = true;
    }

    if (err)
    	return;

    owidth = ClientWidth - 10;
    oheight = ClientHeight - 10;

    if (width <= owidth && height <= oheight) {
    	owidth = width;
        oheight = height;
    }
    else if (width >= height) {
    	oheight = owidth * height / width;
    }
    else {
    	owidth = oheight * width / height;
    }

    Image1->Left = (ClientWidth - owidth) / 2;
    Image1->Top = (ClientHeight - oheight) / 2;
    Image1->Width = owidth;
    Image1->Height = oheight;
    Image1->Picture->Bitmap->Width = owidth;
    Image1->Picture->Bitmap->Height = oheight;
    Image1->Canvas->StretchDraw(Rect(0, 0, owidth, oheight),
     ListForm->Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TOverViewForm::FormShow(TObject *Sender)
{
    FrameForm->ROverView = true;
    FrameForm->OverView1->Checked = true;
    FrameForm->SpeedButton62->Down = true;

	Left = FrameForm->RovLeft;
    Top = FrameForm->RovTop;

    SetFormSize();
    if (FrameForm->MDIChildCount > 0) {
    	if (FrameForm->ActiveMDIChild == ViewForm)
    		DrawOverView();
        else if (FrameForm->ActiveMDIChild == ListForm)
    		DrawListView();
    }
}
//---------------------------------------------------------------------------
void __fastcall TOverViewForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	FrameForm->RovLeft = Left;
    FrameForm->RovTop = Top;
    FrameForm->RovWidth = ClientWidth;
    FrameForm->RovHeight = ClientHeight;

    FrameForm->ROverView = false;
    FrameForm->OverView1->Checked = false;
    FrameForm->SpeedButton62->Down = false;
}
//---------------------------------------------------------------------------
void __fastcall TOverViewForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TOverViewForm::Image1MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (Button == mbLeft) {
    	FrameForm->RovWidth -= 10;
        FrameForm->RovHeight -= 10;
    }
    else if (Button == mbRight) {
    	FrameForm->RovWidth += 10;
        FrameForm->RovHeight += 10;
    }

    SetFormSize();

    try {
    	if (FrameForm->ListSetting && ListForm->Active)
    		DrawListView();
    	else
    		DrawOverView();
    }
    catch (...) {
    	return;
    }
}
//---------------------------------------------------------------------------
void __fastcall TOverViewForm::Panel1MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (Button == mbLeft) {
    	FrameForm->RovWidth -= 10;
        FrameForm->RovHeight -= 10;
    }
    else if (Button == mbRight) {
    	FrameForm->RovWidth += 10;
        FrameForm->RovHeight += 10;
    }

    SetFormSize();

    try {
    	if (FrameForm->ListSetting && ListForm->Active)
    		DrawListView();
    	else
    		DrawOverView();
    }
    catch (...) {
    	return;
    }
}
//---------------------------------------------------------------------------
void __fastcall TOverViewForm::FormActivate(TObject *Sender)
{
    try {
    	if (FrameForm->TextSetting) {
			TextForm->DrawText();
    		TextForm->DrawRing();
    	}
    	else if (FrameForm->AreaSetting) {
			ViewForm->DrawArea();
    	}
    }
    catch (...) {
    	return;
    }
}
//---------------------------------------------------------------------------
void __fastcall TOverViewForm::FormDeactivate(TObject *Sender)
{
    try {
    	if (FrameForm->AreaSetting)
			ViewForm->ClearArea();
    }
    catch (...) {
    	return;
    }
}
//---------------------------------------------------------------------------
